﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LEAPI;

namespace LANIOLIB_sample_Csharp
{
    public partial class Form1 : Form
    {
        int hlanio;
        int model = new int();
        int[] lanio_innum = new int[] { 0, 2, 7, 0, 2, 5, 3, 2, 2, 2, 2 };
        int[] lanio_outnum = new int[] { 0, 3, 0, 5, 5, 0, 3, 2, 2, 2, 2 };
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (LELanio.Init() == 0)
            {
                MessageBox.Show("LELanioInit error.");
                Close();
            }
            Connect.Enabled = false;
            DO1.Enabled = false;
            DO2.Enabled = false;
            DO3.Enabled = false;
            DO4.Enabled = false;
            DO5.Enabled = false;
            GetDI.Enabled = false;
            DI.Text = "";
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            LELanio.End();
        }

        private void Connect_CheckedChanged(object sender, EventArgs e)
        {
            if (Connect.Checked)
            {
                hlanio = LELanio.ConnectDirect(IPaddress.Text.ToString(), 1000);
                if (hlanio == -1)
                {
                    MessageBox.Show("LELanioConnectDirect error.");
                    Connect.Checked = false;
                    return;
                }
                LELanio.GetModel(hlanio, ref model);

                IPaddress.Enabled = false;
                if (lanio_innum[model] > 0)
                {
                    GetDI.Enabled = true;
                }
                if (lanio_outnum[model] < 1) return;
                DO1.Enabled = true;
                if (lanio_outnum[model] < 2) return;
                DO2.Enabled = true;
                if (lanio_outnum[model] < 3) return;
                DO3.Enabled = true;
                if (lanio_outnum[model] < 4) return;
                DO4.Enabled = true;
                if (lanio_outnum[model] < 5) return;
                DO5.Enabled = true;
            }
            else
            {
                LELanio.Close(hlanio);
                IPaddress.Enabled = true;
                GetDI.Enabled = false;
                DO1.Enabled = false;
                DO2.Enabled = false;
                DO3.Enabled = false;
                DO4.Enabled = false;
                DO5.Enabled = false;
                DI.Text = "";
            }
        }

        private void DO1_5_CheckedChanged()
        {
            if (!Connect.Checked)
            {
                return;
            }
            int inbit = new int();
            LELanio.GetOutAll(hlanio, ref inbit);
            int outbit = (inbit & 0xe0) |
                     ((DO1.Checked) ? 0x01 : 0) |
                     ((DO2.Checked) ? 0x02 : 0) |
                     ((DO3.Checked) ? 0x04 : 0) |
                     ((DO4.Checked) ? 0x08 : 0) |
                     ((DO5.Checked) ? 0x10 : 0);
            if (LELanio.OutPioAll(hlanio, outbit) == 0)
            {
                MessageBox.Show("LELanioOutPioAll error.");
                return;
            }
        }

        private void DO1_CheckedChanged(object sender, EventArgs e)
        {
            DO1_5_CheckedChanged();
        }

        private void DO2_CheckedChanged(object sender, EventArgs e)
        {
            DO1_5_CheckedChanged();
        }

        private void DO3_CheckedChanged(object sender, EventArgs e)
        {
            DO1_5_CheckedChanged();
        }

        private void DO4_CheckedChanged(object sender, EventArgs e)
        {
            DO1_5_CheckedChanged();
        }

        private void DO5_CheckedChanged(object sender, EventArgs e)
        {
            DO1_5_CheckedChanged();
        }

        private void GetDI_Click(object sender, EventArgs e)
        {
            int inbit = new int();
            if (LELanio.InPioAll(hlanio, ref inbit) == 0)
            {
                MessageBox.Show("LELanioInPioAll error.");
                return;
            }
            DI.Text = Convert.ToString(inbit, 2).PadLeft(lanio_innum[model], '0');
        }

        private void IPaddress_TextChanged(object sender, EventArgs e)
        {
            if (IPaddress.Text.ToString() != "")
            {
                Connect.Enabled = true;
            }
            else
            {
                Connect.Enabled = false;
            }
        }
    }
}
